> For the complete documentation index, see [llms.txt](https://docs.defisaver.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.defisaver.com/actions/utils/merklclaim.md).

# MerklClaim

### Description

Claims Merkl rewards

> **Notes**
>
> You can claim Merkl rewards for anyone, but distinctTokens array should be empty in that case

### Action ID

`0x79b06cc7`

### SDK Action

```ts
const merklClaimAction = new dfs.actions.merkl.MerklClaimAction(
    users,
    tokens,
    amounts,
    proofs,
    distinctTokens,
    amountsClaimedPerDistinctToken,
    to
);
```

### Action Type

`STANDARD_ACTION`

### Input Parameters

```solidity
    /// @param users Array of addresses who received the reward (from API)
    /// @param tokens The addresses of the tokens that we are claiming the reward in (from API)
    /// @param amounts Amounts to claim (from API)
    /// @param proofs Merkle proofs (from API)
    /// @param distinctTokens Distinct token addresses from tokens array if we want tokens to be sent from smart wallet
    /// @param amountsClaimedPerDistinctToken Amount of tokens to send from smart wallet, amount should match token address at same index in distinctTokens
    /// @param to The address to which the tokens claimed by smart wallet will be sent to
    struct Params {
        address[] users;
        address[] tokens;
        uint256[] amounts;
        bytes32[][] proofs;
        address[] distinctTokens;
        uint256[] amountsClaimedPerDistinctToken;
        address to;
    }
```

### Return Value

```solidity
return bytes32(0);
```

### Events and Logs

```solidity
emit ActionEvent("MerklClaim", logData);
logger.logActionDirectEvent("MerklClaim", logData);
bytes memory logData = abi.encode(params);
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.defisaver.com/actions/utils/merklclaim.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
